#include <alloc.h>
#include <mem.h>

//   , 2002 
//    QGames v2.0  GFX v1.0 (by Flexx)

#define _nop 0
#define _NOP 0
#define _xor 1
#define _XOR 1
#define _and 2
#define _AND 2
#define _or  3
#define _OR  3
#define NoProzr 255

/* ⨯*/
typedef unsigned char BYTE;
typedef unsigned short WORD;
typedef unsigned long DWORD;
typedef unsigned int UINT;

typedef BYTE* PBYTE;
typedef WORD* PWORD;
typedef DWORD* PDWORD;

typedef unsigned char BOOL;
typedef char* PBOOL;

typedef char far* PSTR;
typedef const char far* PCSTR;

#ifndef NULL
#define NULL (void*)(0)
#endif

/*...*/
#define TRUE 1
#define FALSE 0

#define LOBYTE(w)           ((BYTE)(w))
#define HIBYTE(w)           ((BYTE)((UINT)(w) >> 8))

#define LOWORD(l)           ((WORD)(l))
#define HIWORD(l)           ((WORD)((DWORD)(l) >> 16))


#define BOUT(x,y);\
{             \
asm mov dx,x;\
asm mov al,y;\
asm out dx,al;\
}
#define BIN(x,y);\
{            \
asm mov dx,x;\
asm in al,dx;\
asm mov y,al;\
}


typedef struct _RGBPAL
{
	BYTE Red;
	BYTE Green;
	BYTE Blue;
}RGBPAL,* PRGBPAL;

#define TEXT_MODE 0
#define VGA_MODE 1

/*...*/
#define PRESS_KEY 1
#define RELEASE_KEY 2
#define UNKNOWN_KEY 0

#define TAB 9
#define CTRL 0x9d
#define ALT 0xb8
#define SHIFT 0xb6
#define PRNTSCR 0xe0
#define LEFT 0xac
#define UP 0xad
#define RIGHT 0xae
#define DOWN 0xaf
#define ENTER 0xd
#define ESC 0x1b
#define SPACE 0x20
#define END 0xcf
#define HOME 0xc7
#define PGUP 0xc9
#define PGDOWN 0xd1
#define INSERT 0xd2
#define DEL 0xd3
#define DELETE 0x7f
#define F1 0xbb
#define F2 0xbc
#define F3 0xbd
#define F4 0xbe
#define F5 0xbf
#define F6 0xc0
#define F7 0xc1
#define F8 0xc2
#define F9 0xc3
#define F10 0xc4

BYTE Key=0;  // For AnyKey
#define ANYKEY;\
while (!GetKey(ENTER));\

typedef struct _STMOUSEMAP
{
	WORD PosX,PosY;
	BOOL RightKey,LeftKey;
}STMOUSEMAP,* PSTMOUSEMAP;


WORD libBufferKeyboard[32];
BYTE libBufferChars[16];
BYTE libCharsCounter1 = 0;
BYTE libCharsCounter2 = 0;
BOOL libKeyboard     = 0;
BOOL libKeyMsg       = 0;

const BYTE libTabChar[] =
{
	  0,0x1b,0x31,0x32,0x33,0x34,0x35,0x36,0x37,0x38,0x39,
	  0x30,0x2d,0x3d,0x7f,9,0x71,0x77,0x65,0x72,0x74,0x79,
	  0x75,0x69,0x6f,0x70,0x5b,0x5d,0x0d,0x9d,0x61,0x73,0x64,
	  0x66,0x67,0x68,0x6a,0x6b,0x6c,0x3b,0x27,0x60,0xfe,0x5c,
	  0x7a,0x78,0x63,0x76,0x62,0x6e,0x6d,0x2c,0x2e,0x2f,0xb6,
	  0xe0,0xb8,0x20,0,0xbb,0xbc,0xbd,0xbe,0xbf,0xc0,0xc1,0xc2,
	  0xc3,0xc4,0,0,0xc7,0xad,0xc9,0x2d,0xac,0x35,0xae,0x2b,0xef,
	  0xaf,0xd1,0xd2,0xd3,0,0,0,0xd7,0xd8,0,0,0,0,0,0,0,0,0,0,0,0
	  ,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
};

/*㭪樨...*/
#ifdef __cplusplus
    #define __CPPARGS ...
#else
    #define __CPPARGS
#endif

void interrupt ( *libFunKbOldInter)(__CPPARGS);

typedef void(far* FNTIMER)(void);



BOOL libTimer = 0;
WORD libCounter;
WORD libTimerFreq;
BOOL libTimerFunc;
FNTIMER libfnTimer;
const BYTE libAddrChannels1[18] =
	{ 0x00,0x01,0x02,0x08,0x09,0x0A,0x10,0x11,0x12 ,
		0x03,0x04,0x05,0x0B,0x0C,0x0D,0x13,0x14,0x15 };
const BYTE libAddrChannels2[9] =
	{ 0x03,0x04,0x05,0x0B,0x0C,0x0D,0x13,0x14,0x15 };

/*㭪樨...*/
void interrupt far ( *libFunTmOldInter)(__CPPARGS);
//void interrupt libTimerInterrupt(__CPPARGS);

BOOL GetKey(BYTE KeyNum);

char far *tmp=(char far *) 0;
BYTE libDisplayMode;
PSTR libVirScreen = (PSTR)0xA0000000;

typedef struct _RGB
{    char Red,Green,Blue;  } RGB;

unsigned int xy(int x,int y)
 {  asm { mov ax,y
	xchg ah,al
	mov bx,x
	add bx,ax
	shr ax,2
	add bx,ax }
	return (_BX);  }

void WaitDisplayVrt(void)
//  ⭮ 室 
{
	register BYTE Value;
	do
	{
		BIN(0x3DA,Value);
	}while(!(Value & 8));
}

BOOL GetDisplayVrt(void)
// 室 .
{
	register BYTE Value;
	BIN(0x3DA,Value);
	return Value & 8;
}


void SetDisplayMode(BYTE Mode)
// ⠭ ० ࠭: TEXT_MODE - ⥪⮢, VGA_MODE - 320x200x256
{
	libDisplayMode = Mode;
	switch(Mode)
	{
	case TEXT_MODE:
		asm mov ax,3;
		asm int 0x10;
		return;
	case VGA_MODE:
		asm mov ax,0x13
		asm int 0x10;
		return;
	default:
		return;
	}
}

void SetDisplayPal(PRGBPAL pRgbPal)
//⠭  ࠭  ᨢ pRgbPal ⨯  PRGBPAL
{
	WaitDisplayVrt();
	BOUT(0x3C8,0);
	asm mov cx,768;
	asm mov dx,0x3C9;
	asm les di,pRgbPal;
NEXTPAL:
	asm mov al,[es:di];
	asm shr al,2;
	asm out dx,al;
	asm inc di;
	asm loop NEXTPAL;
}

void SetPal(char* pRgbPal)
// ⠭   筮 ᨢ.
{
	WaitDisplayVrt();
	BOUT(0x3C8,0);

	asm mov cx,768;
	asm mov dx,0x3C9;
	asm les di,pRgbPal;
NEXTPAL:
	asm mov al,[es:di];
	asm shr al,2;
	asm out dx,al;
	asm inc di;
	asm loop NEXTPAL;
}


void PutPixel (int x,int y, char col, int mode)
/*楤 ⠢  㪠 梥⮬
mode - ०  OR,XOR,AND,NOP */
{
   switch (mode) {
     case _nop: *(libVirScreen+xy(x,y)) = col; break;
     case _xor: *(tmp = libVirScreen+xy(x,y)) = *tmp^col;break;
     case _and: *(tmp = libVirScreen+xy(x,y)) = *tmp&col;break;
     case _or: *(tmp = libVirScreen+xy(x,y)) = *tmp|col;break; }
}

BYTE GetPixel (int x,int y)
// 楤 頥 梥 窨  㪠 न⠬
{ return (*(libVirScreen + xy(x,y))); }

void DrawFillBox (int x1,int y1,int x2,int y2,int color)
/*  襭 אַ㣮쭨
x1,y1 - 孨  㣮 אַ㣮쭨
x2,y2 -  ࠢ 㣮 אַ㣮쭨
color - 梥 0-255 */
{ int x,y;
for (y=y1; y<=y2; y++) for (x=x1; x<=x2; x++) *(libVirScreen + xy(x,y))=color; }

void DrawBox (int x1,int y1,int x2,int y2,int color)
/*   אַ㣮쭨
x1,y1 - 孨  㣮 אַ㣮쭨
x2,y2 -  ࠢ 㣮 אַ㣮쭨
color - 梥 ࠬ */
{ int x,y;
 y=y1; for (x=x1; x<=x2; x++) *(libVirScreen + xy(x,y))=color;
 y=y2; for (x=x1; x<=x2; x++) *(libVirScreen + xy(x,y))=color;
 for (y=y1; y<=y2; y++) { *(libVirScreen + xy(x1,y))=color; *(libVirScreen + xy(x2,y))=color; } }

void PutSprite (int x1,int y1,char *buf,int mode,int prozr)
/* 뢮  ࠭ ࠩ  ᨢ buf
x,y - न   ࠭
mode - _NOP, _AND, _OR  _XOR (०  ࠩ)
prozr -  ஧筮 梥 (NoProzr -  ஧筮 梥) */
{ int a,x,y;
BYTE hi = buf[0]; BYTE lo = buf[1];
unsigned int len = (hi*256)+lo-1;
hi = buf[2]; lo = buf[3];
unsigned int hgt = (hi*256)+lo-1;
a=4;
 if (prozr != NoProzr) {
	      switch (mode) {
     case _nop:
	      for (y=y1; y<=(y1+hgt); ++y) for (x=x1; x<=(x1+len); ++x) {
	      if (buf[a] != prozr)
		*(libVirScreen+xy(x,y)) = buf[a++];
	      else a++;  }
     break;
     case _xor:
	      for (y=y1; y<=(y1+hgt); ++y) for (x=x1; x<=(x1+len); ++x) {
	      if (buf[a] != prozr)
		*(tmp = libVirScreen+xy(x,y)) = *tmp^buf[a++];
	      else a++;  }
     break;
     case _and:
	      for (y=y1; y<=(y1+hgt); ++y) for (x=x1; x<=(x1+len); ++x) {
	      if (buf[a] != prozr)
		 *(tmp = libVirScreen+xy(x,y)) = *tmp&buf[a++];
	      else a++;  }
     break;
     case _or:
	      for (y=y1; y<=(y1+hgt); ++y) for (x=x1; x<=(x1+len); ++x) {
	      if (buf[a] != prozr)
		 *(tmp = libVirScreen+xy(x,y)) = *tmp|buf[a++];
	      else a++;  }  } }

    else  {
	      switch (mode) {
     case _nop:
	      for (y=y1; y<=(y1+hgt); ++y) for (x=x1; x<=(x1+len); ++x)
	      *(libVirScreen+xy(x,y)) = buf[a++];
     break;

     case _xor:
	      for (y=y1; y<=(y1+hgt); ++y) for (x=x1; x<=(x1+len); ++x)
	      *(tmp = libVirScreen+xy(x,y)) = *tmp^buf[a++];
     break;
     case _and:
	      for (y=y1; y<=(y1+hgt); ++y) for (x=x1; x<=(x1+len); ++x)
	      *(tmp = libVirScreen+xy(x,y)) = *tmp&buf[a++];
     break;
     case _or:
	      for (y=y1; y<=(y1+hgt); ++y) for (x=x1; x<=(x1+len); ++x)
	      *(tmp = libVirScreen+xy(x,y)) = *tmp|buf[a++];  } }  }


void GetSprite (int sx,int sy, BYTE slen, BYTE shgt, PSTR Buffer)
{
//࠭    Buffer  ଠ ࠩ
// 2  -   
//sx,sy - न
//slen,shgt -    
int x,y,a=4;
Buffer[0]=0; Buffer[1] = slen+1; Buffer[2] = 0; Buffer[3] = shgt;
for (y=sy; y <= sy+shgt; y++)
  for (x=sx; x <= sx+slen; x++)
   Buffer[a++] = *(libVirScreen + xy(x,y));
}

void SetPalReg(char color, char r,char g,char b)
// ⠭ ॣ color  梥 r,g,b
{
  asm mov dx,0x3c8
  asm mov al,color
  asm out dx,al
  asm inc dx
  asm mov al,r
  asm out dx,al
  asm mov al,g
  asm out dx,al
  asm mov al,b
  asm out dx,al
}

void MorphPalReg (char color,int r,int g,int b,int r1,int g1,int b1)
/*    ॣ color મ ᭮,   ᨭ
 稭 r1-r, g1-g, b1-b. r,g,b - 砫 梥, r1,g1,b1 -  梥
*/
{
  while (r==r1 && g==g1 && b==b1)  {
  if (r!=r1)
    {
      if (r<r1)  r++;
      else r--;
    }
  if (g!=g1)
    {
      if (g<g1) g++;
      else g--;
    }
  if (b!=b1)
    {
      if (b<b1) b++;
      else b--;
    }
  asm mov dx,0x3da
  test_beam:
  asm in al,dx
  asm nop
  asm test al,8
  asm jz test_beam
  SetPalReg (color,r,g,b);         }
  return;
}

void DecPalReg (int color, RGB rgb)
// 蠥 મ color  1
{
unsigned char r,g,b;
  r = rgb.Red;
  g = rgb.Green;
  b = rgb.Blue;
  if (r>0) r--;
  if (g>0) g--;
  if (b>0) b--;
  asm mov dx,0x3da
  test_beam:
  asm in al,dx
  asm nop
  asm test al,8
  asm jz test_beam
  SetPalReg (color,r,g,b);
}

void IncPalReg (int color, RGB rgb)
// 稢 મ color  1
{
unsigned char r,g,b;
  r = rgb.Red;
  g = rgb.Green;
  b = rgb.Blue;
  if (r<255) r++;
  if (g<255) g++;
  if (b<255) b++;
  asm mov dx,0x3da
  test_beam:
  asm in al,dx
  asm nop
  asm test al,8
  asm jz test_beam
  SetPalReg (color,r,g,b);
}

void PaletteOff (PRGBPAL pal)  //   梥
{
  for (int y=0; y<=255 ; y++)
   {
     for (int x=0; x<=255 ; x++)
       {
	 if (pal[x].Red>0) --pal[x].Red;
	 if (pal[x].Green>0) --pal[x].Green;
	 if (pal[x].Blue>0) --pal[x].Blue;
       }
     SetDisplayPal (pal);
   }
}

void PaletteMorph (PRGBPAL src_pal, PRGBPAL dest_pal)
// ८ࠧ뢠  src_pal  dest_pal
{
  for (int y=0; y<=255 ; y++)
   {
     for (int x=0; x<=255 ; x++)
       {
	 if (src_pal[x].Red < dest_pal[x].Red) ++src_pal[x].Red;
	    else if (src_pal[x].Red > dest_pal[x].Red) --src_pal[x].Red;

	 if (src_pal[x].Green < dest_pal[x].Green) ++src_pal[x].Green;
	    else if (src_pal[x].Green > dest_pal[x].Green) --src_pal[x].Green;

	 if (src_pal[x].Blue < dest_pal[x].Blue) ++src_pal[x].Blue;
	    else if (src_pal[x].Blue > dest_pal[x].Blue) --src_pal[x].Blue;
       }
     SetDisplayPal (src_pal);
   }
}

void PaletteNull (PRGBPAL pal)
// 塞  pal ﬨ
{
  asm { push es
	les di,pal
	mov cx,768
	xor ax,ax
	cld
	rep stosb
	pop es}
}

void PaletteFF (PRGBPAL pal)
// 塞  pal 祭 0ffh
{
  asm { push es
	les di,pal
	mov cx,768
	mov al,255
	cld
	rep stosb
	pop es}
}


void ClearLines (int begin, int end, char color)
// 頥  ࠭  begin  end 梥⮬ color
{
  int adr;
  for (int x=begin; x <= end; x++) {
     adr = xy(0,x);
     asm { les di,libVirScreen
	   add di,adr
	   mov cx,160
	   mov al,color
	   mov ah,al
	   cld
	   rep stosw }  }
}



void CopyVirToScr_WDV(void)
// ॡ᪠ 㠫쭮 ࠭     ⭮ 室 
{
	register BYTE Value;
	do
	{
		BIN(0x3DA,Value);
	}while(!(Value & 8));

	asm push ds;
	asm lds si,libVirScreen;
	asm mov di,0xA000;
	asm mov es,di;
	asm xor di,di;
	asm mov cx,32000;
	asm cld;
	asm rep movsw;
	asm pop ds;
}

void CopyVirToScr(void)
// ॡ᪠ ࠭    
{
	asm push ds;
	asm lds si,libVirScreen;
	asm mov di,0xA000;
	asm mov es,di;
	asm xor di,di;
	asm mov cx,32000;
	asm cld;
	asm rep movsw;
	asm pop ds;
}

void ClearScreen(BYTE bColor)
//⪠ ࠭  梥⮬
{
	asm mov al,bColor;
	asm les di,libVirScreen;
	asm mov ah,al;
	asm mov cx,32000;
	asm cld;
	asm rep stosw;
}

void SetVirScreen(PSTR pBuffer)
// ⠭ ⥪饣 㠫쭮 ࠭
{
	libVirScreen = pBuffer;
}

void CopyBufToPal (PRGBPAL bufpal, char *buf)
// ஢   筮     RGBPAL
{
  asm {
	push ds
	push es
	lds si,buf
	les di,bufpal
	mov cx,768
	rep movsb
	pop es
	pop ds
      }
}

void Delay (unsigned long delay)
// Delay
{
  for (unsigned long x=1; x<= delay; x++)
      WaitDisplayVrt ();
}


/*...*/


void interrupt libKeyboardInterrupt(__CPPARGS)
{
	static BYTE KeyCode;
	static BYTE Index,ExIndex;
	static BYTE Byte;

	BIN(0x60,KeyCode);
	Index   = libTabChar[KeyCode & 0x7F];
	ExIndex = Index & 7;
	Byte = libBufferKeyboard[Index >> 3];

	if(KeyCode & 0x80)
		Byte &= ~(1 << ExIndex);
	else
	{
		libCharsCounter1 &= 0xF;
		libBufferChars[libCharsCounter1++] = Index;
		Byte |= 1 << ExIndex;
	}

	libBufferKeyboard[Index >> 3] = Byte;
	BOUT(0x20,0x20);
}

void DosKeyboard()
{
	if(!libKeyboard)
		return;
	setvect(9,libFunKbOldInter);
	libKeyboard = FALSE;
}


void QGamesKeyboard()
{
	if(libKeyboard)
		return;

	libFunKbOldInter = getvect(9);
	setvect(9,libKeyboardInterrupt);
	memset(libBufferKeyboard,0,32);
	libKeyboard = TRUE;
}


BOOL GetKey(BYTE KeyNum)
{
	if(libBufferKeyboard[KeyNum >> 3] & (1 << (KeyNum & 7)))
		return TRUE;
	return FALSE;
}

BYTE GetChar(BOOL bPause)
{
	if(libCharsCounter1 == libCharsCounter2)
	{
		if(!bPause)
			return 0;
		while(libCharsCounter1 == libCharsCounter2);
	}
	libCharsCounter2 &= 0xF;
	return libBufferChars[libCharsCounter2++];
}

void ResetKeyChars(void)
{
	libCharsCounter2 = libCharsCounter1 = 0;
}
/*...*/

BOOL GetMouseInit()
{
	asm mov ax,0;
	asm int 0x33;
	if(!_AX)
		return FALSE;
	return TRUE;
}

void MouseCursorOn()
{
	asm mov ax,1;
	asm int 0x33;
}

void MouseCursorOff()
{
	asm mov ax,2;
	asm int 0x33;
}

void SetMouseCursor(WORD HotX,WORD HotY,PBYTE pBit)
{
	if(HotX > 16 || HotY > 16)
		return;

	asm mov ax,9;
	asm mov bx,HotX;
	asm mov cx,HotY;
	asm les dx,pBit;
	asm int 0x33;
}

void GetMouseMap(PSTMOUSEMAP pstMMap)
{
	WORD X,Y,Keys;
	asm mov ax,3;
	asm int 0x33;
	asm mov Keys,bx;
	asm mov X,cx;
	asm mov Y,dx;

	if(libDisplayMode == VGA_MODE)
		X = X >> 1;
	else if(libDisplayMode == TEXT_MODE)
	{
		X = X >> 3;
	Y = Y >> 3;
	}
	pstMMap->PosY = Y;
	pstMMap->PosX = X;
	pstMMap->RightKey = Keys & 2;
	pstMMap->LeftKey  = Keys & 1;

}

void SetCursorPos(int PosX,int PosY)
{
	if(libDisplayMode == VGA_MODE)
		PosX = PosX << 1;
	else if(libDisplayMode == TEXT_MODE)
	{
		PosX = PosX << 3;
		PosY = PosY << 3;
	}
	asm mov ax,4;
	asm mov cx,PosX;
	asm mov dx,PosY;
	asm int 0x33;
}

void GetMouseMoving(int* MoveX,int* MoveY)
{
	asm mov ax,0xb;
	asm int 0x33;
	asm les di,MoveX;
	asm mov [es:di],cx;
	asm les di,MoveY;
	asm mov [es:di],dx;
}

void interrupt libTimerInterrupt(__CPPARGS)
{
	libCounter++;
	if(!(libCounter % libTimerFreq))
		(*libFunTmOldInter)();

	if(!libTimerFunc && libfnTimer != NULL)
	{
		libTimerFunc = TRUE;
		libfnTimer();
		libTimerFunc = FALSE;
	}
	BOUT(0x20,0x20);
}


void SetTimer(WORD Speed)
{
	outp(0x43,0x36);
	outp(0x40,Speed & 0xFF);
	outp(0x40,(Speed >> 8) & 0xFF);
}


void GamesTimer(WORD Freq)
{
	WORD RealFreq;
	if(!libTimer)
	{
		libFunTmOldInter = getvect(8);
		setvect(8,libTimerInterrupt);
	}
	if(Freq < 36)
	{
		libTimerFreq = 2;
		Freq = 36;
	}
	else
		libTimerFreq = Freq/18;

	SetTimer(0xFFFF/libTimerFreq);
	libCounter = 0;
	libTimer = TRUE;
	libTimerFunc = FALSE;
	libfnTimer   = NULL;
}

void DosTimer()
{
//	if(!libTimer)
//		return;

	SetTimer(0xFFFF);
	setvect(8,libFunTmOldInter);
	libTimer = FALSE;
}

void SetTimerFunc(FNTIMER fnTimer)
{
	libfnTimer = fnTimer;
	libTimerFunc = FALSE;
}

WORD GetTimerCounter()
{
	return libCounter;
}
